Priority: Normal Due date:  
Description

The exception is :

lib/redmine/plugin.rb:141:in `find': Redmine::PluginNotFound (Redmine::PluginNotFound)

 It would be better if it is :

lib/redmine/plugin.rb:273:in `rescue in requires_redmine_plugin': redmine_smile_enhancements plugi

n requires plugin redmine_smile_base (Redmine::PluginNotFound)

Associated revisions

Revision 17960 - 2019-03-15 09:01 - Jean-Philippe Lang

Include plugin name in the exception when the plugin required by requires_redmine_plugin is not found (#31030).

Patch by Jérôme BATAILLE and Go MAEDA.

Revision 17961 - 2019-03-15 09:01 - Jean-Philippe Lang

Merged r17960 to 4.0-stable (#31030).

Revision 17966 - 2019-03-15 10:49 - Jean-Philippe Lang

PluginRequirementError is now raised instead of PluginNotFound (#31030).

Revision 17967 - 2019-03-15 10:50 - Jean-Philippe Lang

Merged r17966 to 4.0-stable (#31030).

History

#1 - 2019-03-14 16:06 - Jérôme BATAILLE

- File RM_dependant_plugin_missing_exception_svn.diff added

Here is the patch.

#2 - 2019-03-15 03:27 - Go MAEDA

- Category changed from Core Plugins to Plugin API

- Target version set to Candidate for next minor release

I think it should catch only PluginNotFound exception.

diff --git a/lib/redmine/plugin.rb b/lib/redmine/plugin.rb

index ec575d17a..16e266da1 100644

--- a/lib/redmine/plugin.rb

+++ b/lib/redmine/plugin.rb

@@ -270,7 +270,11 @@ module Redmine

       arg = { :version_or_higher => arg } unless arg.is_a?(Hash)

       arg.assert_valid_keys(:version, :version_or_higher)

-      plugin = Plugin.find(plugin_name)
+      begin

+        plugin = Plugin.find(plugin_name)

+      rescue PluginNotFound

+        raise PluginRequirementError.new("#{id} plugin requires the #{plugin_name} plugin")

+      end

       current = plugin.version.split('.').collect(&:to_i)

       arg.each do |k, v|

#3 - 2019-03-15 04:25 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.0.3

Setting the target version to 4.0.3.

#4 - 2019-03-15 08:41 - Go MAEDA

- Subject changed from Missing dependant plugin : give missing plugin name in exception to Include plugin name in the exception when the plugin

required by requires_redmine_plugin is not found

#5 - 2019-03-15 09:01 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

Committed, thanks.

#6 - 2019-05-24 23:10 - Jérôme BATAILLE

Thanks to have merged this patch.

Files

RM_dependant_plugin_missing_exception_svn.diff 603 Bytes 2019-03-14 Jérôme BATAILLE
